#!/usr/bin/perl
# Perl-Programm fuer CapiCall-Callback-Button auf Webseite

# Bitte passen Sie die folgenden Angaben an:
$job = "C:\\CAPICALL\\DIAL.JOB"; # Jobdatei fuer CapiCall inkl. Pfad
$nst = "32";  # Interne Rufnummer oder Sammelrufnummer
$kng = "*";   # Kennung fr Logdatei bzw. Ziel fr Netzwerk-Popup
$amt = "";    # Amtsholung fr Tk-Anlage: ggf. "0" statt ""

# Ab hier sollten nur Perl-Kundige nderungen vornehmen!
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{ ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;  # HTTP-Escaping beseitigen
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
}
$tel=$FORM{'Tel'};

$tel =~ s/,//g; # Kommas aus Tel-Nr. entfernen
if (length $tel >1) # Zeile an CapiCall-Jobdatei anhaengen:
{ open (JOBF, ">>".$job) || die "Kann $job nicht oeffnen!";
  print JOBF "5,00.00.0000 00:00,301,$amt$tel,60,$kng\n";
  close JOBF;
  $answer = "Danke! Wir werden Sie in Krze zurckrufen.";
}
else
{ $answer = "Fehlende oder falsche Telefonnummer.";
}

# Besttigung als Webseite anzeigen
print "Content-Type: text/html\n\n<html><head>
<title>Rckruf</title></head><body bgcolor=\"#FFE0A8\">
<h2>Rckruf</h2><h3>$answer</h3>
<h4><a href=\"/\">Zur Leitseite</a></h4>
<p>[Powered by Shamrock CapiCall]</p>
</body></html>\n";

exit (0);
