'Erzeugen von Verlosungs-Ansagedateien fr CapiCall (Quickbasic 4.5)
 DECLARE SUB CopyPart (d$)
 DEFINT A-Z
 CONST cc$ = "INTERN\CCZIFF_" 'Ziffernansagen
 CONST pcm$ = ".PCM" ' Endung der Sprachdateien

'Kommandozeilenparameter extrahieren
 ON ERROR GOTO fail
 e$ = COMMAND$: i = INSTR(e$, " ")
 IF i < 2 THEN
  PRINT "Erzeugung einer Verlosungsliste fr CapiCall"
  PRINT "Aufruf:  MAKEPINS Quelldatei Zielverzeichnis": GOTO abort
 END IF
 d$ = LEFT$(e$, i - 1): p$ = LTRIM$(MID$(e$, i + 1))
 IF RIGHT$(p$, 1) <> "\" THEN p$ = p$ + "\"

'Quelldatei probelesen: Alles ok?
 OPEN d$ FOR INPUT SHARED AS 1: j = 0
 u$ = " </>*?+,;.:\" + CHR$(34)' Unzulssige Zeichen
 WHILE NOT EOF(1) AND j = 0
  LINE INPUT #1, e$: e$ = RTRIM$(e$): i = LEN(e$)
  IF i THEN 'Leerzeilen berlesen
   IF i < 2 OR i > 9 THEN PRINT "PIN-Lnge = 2-9 Zeichen!": j = -1
   IF NOT j THEN
    FOR i = 1 TO LEN(u$)
     IF INSTR(e$, MID$(u$, i, 1)) THEN
      j = -1: PRINT "Quelldatei ungeeignet": EXIT FOR
     END IF
    NEXT
   END IF
  END IF
 WEND: CLOSE 1: IF j THEN GOTO abort

'Ok, Zieldateien erzeugen
 OPEN d$ FOR INPUT SHARED AS 1
 WHILE NOT EOF(1)
  LINE INPUT #1, e$: e$ = RTRIM$(e$)
  IF LEN(e$) THEN 'Leerzeilen ignorieren
   d$ = p$ + LEFT$(e$, 8) + pcm$
   OPEN d$ FOR OUTPUT SHARED AS 3: CLOSE 3' Lnge=0, falls Datei schon existiert
   OPEN d$ FOR BINARY ACCESS WRITE SHARED AS 3' Binr schreiben
   FOR i = 1 TO LEN(e$)' PCM-Datei aus Ziffernansagen zusammenkopieren
    d$ = cc$ + MID$(e$, i, 1) + pcm$: CopyPart d$
   NEXT: CLOSE 3: cnt = cnt + 1
  END IF
 WEND: CLOSE 1
 PRINT "Erzeugte PIN-Dateien: "; cnt
 END

'Fehlerbehandlung
fail:  PRINT "Fehler beim ffnen von "; d$
abort: PRINT "[Taste]": BEEP: e$ = INPUT$(1): END

SUB CopyPart (d$) 'Kopiert Datei d$ als nchstes Stck in Handle #3
 OPEN d$ FOR INPUT SHARED AS 2: CLOSE 2' Datei da?
 OPEN d$ FOR BINARY ACCESS READ SHARED AS 2' benutzt selber Handle 2!
 DO
  ln& = LOF(2) - SEEK(2) + 1: IF ln& > 512 THEN ln& = 512
  b$ = SPACE$(ln&): GET 2, , b$: PUT 3, , b$
 LOOP UNTIL ln& < 512: CLOSE 2
END SUB

