#!/usr/bin/perl

# Perl-Programm fr Ihren Web-Server: Anrufwunsch eines Kunden
# als E-Mail an NetMail senden, so da NetMail eine Datei
# Dial.job fr CapiCall erzeugt. (c) Shamrock Software GmbH

# Bitte passen Sie die folgenden Zeilen an Ihre Konfiguration an:

$to='Job-Daemon@IhreFirma.de'; # "IhreFirma.de" durch Ihre Domain ersetzen,
             # "Job-Daemon" lassen, damit NetMail diese Mail verarbeitet!
$su='XY42';  # Betreffkennwort fr den NetMail-Benutzer "Job-Daemon"
$amt='';     # hier ggf. $amt='0' fr Amts-Null vor der Kunden-Telefonnr.
$nr='32';    # Tel.-Nummer Ihres Mitarbeiters, der den Kunden anrufen soll
$t1='09:00'; # Beginn Ihrer Brozeit
$t2='17:30'; # Bis zu dieser Zeit werden Anrufwnsche akzeptiert

# Feste und bewegliche Feiertage (ggf. anpassen an Bundesland!)
@holidays=('01.01','01.05','03.10','01.11','24.12','25.12','26.12',
 '06.01.2005','09.02.2005 ','25.03.2005','28.03.2005',
 '05.05.2005','16.05.2005','31.12.2005');

# --- Ab hier sind normalerweise keine Anpassungen mehr ntig! ---

$mailprog='/usr/sbin/sendmail';

# Felder aus HMTL-Formular bernehmen
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{ ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /; # HTTP-Escaping beseitigen
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ tr/,/ /; # Kommas zu Spaces
  $FORM{$name} = $value;
}

# Datum und Zeit
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
$mon++; $year%=100; $year+=2000; @zz=('00'..'59');
$dt = "$zz[$mday].$zz[$mon].$year"; # Datum tt.mm.jjjj
$ti=$FORM{'Time'};
if ($ti eq '') { $ti = "$zz[$hour]:$zz[$min]"; }
elsif (length($ti)!=5||index($ti,':')!=2) { &refuse("Uhrzeit-Formatfehler");}
foreach $d (@holidays)
{ if ($dt =~ /^$d/)
  { &refuse("An Feiertagen ist unser Bro leider geschlossen.");
  }
}
if ($wday==6 || $wday==0)
{ &refuse("Am Samstag und Sonntag ist unser Bro leider geschlossen.");}
if ($ti lt $t1 || $ti gt $t2)
{ &refuse("Leider knnen wir Anrufwnsche nur von $t1 bis $t2 entgegennehmen.");
}
# Plausibilitts-Check
if (length $FORM{'Name'} < 2) { &refuse("Name fehlt");}
$FORM{'Phone'} =~s/[^0-9]//g; # Aus Tel.-Nr. nur Ziffern bernehmen
if (length $FORM{'Phone'} < 2) { &refuse("Telefonnummer fehlt"); }

# Nummern ablehnen, die mit 00, 01, 11 beginnen, z.B. Ausland, 0190, 112
if ($FORM{'Phone'} =~ /^00|01|11/)
{ &refuse("Nur fr normale nationale Festnetz-Nummern");
}

# Mail erzeugen. Der vom Kunden eingebene Name wird
# ggf. im Popup-Programm CC_POPUP gemeldet!
open (MAIL, "|$mailprog $to") || die "Can't open $mailprog!\n";
print MAIL "From: JOB-DAEMON\@$ENV{'HTTP_HOST'}
To: $to
Subject: $FORM{'Name'} $su
Mime-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit\n\n";

# Dial.job-Zeile: Versuche,Zeit,Intern-Nummer,Zielnummer,Pause,Kennung
print MAIL "CapiCall/DIAL.JOB:5,$dt $ti,$amt$nr,$FORM{'Phone'},300,*\n";
close (MAIL);

# Besttigung als Webseite anzeigen
print "Content-Type: text/html\n\n<html><head>
<title>Anruf</title></head><body bgcolor=\"#FFDA95\">
<h2>Danke fr Ihr Interesse!</h2><h3>Wir werden in Krze versuchen, Sie zu erreichen.</h3>
<h4><a href=\"/\">Startseite</a></h4>
</body></html>\n";
exit (0);

# Fehler anzeigen
sub refuse {
print "Content-type: text/html\n\n<html><head>
<title>Problem</title></head><body bgcolor=\"#FFDA95\">
<h2>Problem</h2><h3>$_[0]</h3>
<h4><a href=\"javascript:history.back()\">Zurck - Back</a></h4></body></html>\n";
exit (0); }
